#include <winsock.h>
#include <stdio.h>
#include <conio.h>

using namespace std;

int initsocklib()
{
    WSADATA init;

    if (WSAStartup(MAKEWORD(1,1),&init) != 0)
    {
      return (0);
    }

    return (1);
}

SOCKET connect()
{
    struct sockaddr_in sin;
    struct hostent *hp;
    //char *host;
    SOCKET s = (SOCKET)NULL;
	char *server1 = "127.0.0.1";

    memset(&sin, 0, sizeof(struct sockaddr_in));

    hp = gethostbyname(server1);

    if (!hp)
    {
        return (0);
    }   

    sin.sin_family = AF_INET;
  
    memcpy((char *)&sin.sin_addr,hp->h_addr_list[0],hp->h_length);
    sin.sin_port = htons(25225);

    if ((s = socket(hp->h_addrtype, SOCK_STREAM, 0)) <0)
    {
        printf("Could not create socket\n");
        return (0);
    }
    printf("Socket Created\n");
    if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0)
    {
        printf("Could not connect to BBSocket at 25225\n");
        closesocket(s);
        return (0);
    }
    return (s);
}

int main(int argc, char *argv[])
{
    SOCKET MyIn;
    char bufIn[1024],bufOut[1024];
    initsocklib();
    int numIn=0,numOut=0;
    int type=0;
    if(MyIn=connect())
    {
     printf("Connected to BBSocket\n");
     printf("Type a bro@m followed by ';' to send to blackbox\n");
     printf("Type a command followed by a ';' to send it to blackbox\n");
     printf("For supported commands see the BBSocket readme\n");
     printf("Do NOT press \"ENTER\" at any time, press ';' to get a new line\n");
     u_long arg = 1;
     ioctlsocket(MyIn, FIONBIO, &arg);
     while(1)
     {
            if (kbhit())
            {
                bufOut[numOut++]=getch();
                printf("%c",bufOut[numOut-1]);
            }
            if (bufOut[numOut-1]==';')
            {
                bufOut[numOut-1]=0;
                printf("\n\a",bufOut);
                send(MyIn,bufOut,strlen(bufOut)+1,0);
                numOut=0;
            }
            numIn=recv(MyIn,bufIn,100,0);
            if (numIn>0) puts(bufIn);
             
     }
    }
    system("PAUSE");
    return EXIT_SUCCESS;
}
